/*********************************************************************
  ulib/graphics/draw/draw.hh

  purpose:

  notes:

  to do:

  author(s):
   - Dirk Farin, farin@ti.uni-mannheim.de
     University Mannheim, Dept. Circuitry and Simulation
     B 6,26 EG, room 0.10 / D-68131 Mannheim / Germany

  modifications:
    17/Nov/1999 - Dirk Farin - converted bitmap drawing functions to
                               function templates.
 *********************************************************************/

#ifndef ULIB_GRAPHICS_DRAW_DRAW_HH
#define ULIB_GRAPHICS_DRAW_DRAW_HH

#include "ulib/graphics/basic/bitmap.hh"
#include "ulib/graphics/basic/image.hh"

/* This function-call is very inefficient but provides clipping. */
template <class T> void DrawPoint     (Bitmap<T>&,int x,int y,T color);

template <class T> void DrawLine      (Bitmap<T>&,int x1,int y1,int x2,int y2,T color);

/* Only draws every 4th dot. */
template <class T> void DrawDottedLine(Bitmap<T>&,int x1,int y1,int x2,int y2,T color);

/* Set all of the bitmap to the specified color. */
template <class T> void Clear         (Bitmap<T>&,T color);


/* Copy a number of lines at the inner border of the image. */
void CopyInnerBorder(const Image<Pixel>& src,Image<Pixel>& dst,int hwidth,int vwidth);

/* Creates a border of the specified with around the image and copies the border
   pixel values into it. */
void EnhanceImageWithBorder(Image<Pixel>& img,int borderwidth,bool exactsize=false);

#endif
